/***************************************************************************
*    Copyright 2001  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: rekeyReply.h
*    Creation Date: 5 November 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.2 $
*        $Date: 2005/02/17 21:13:24 $
*
****************************************************************************
*    Description:
*
*      Header file for Implementation of rekey replay protection
*
****************************************************************************/

#ifndef REKEYREPLAY_H
#define REKEYREPLAY_H



#ifdef __cplusplus
extern "C"
{
#endif


#include <string.h>
#include <SecLib.h>
#include <ChKerbNamespace.h>


typedef enum
{
   REKEY_REPLAY_FOUND,
   REKEY_REPLAY_NOT_FOUND,
} REKEY_STATUS;


/*
******************************************************************************
** FUNCTION:  secStoreRekeyMessage
**
** PURPOSE:   store a rekey message, (only nonce, fqdn, timestamp)
**
** PARAMETERS:
**    1. nonce 
**    2. fqdn of call agent
**    3. timestamp form the rekey message
**
**
** RETURNS:
**
** NOTE:
**
******************************************************************************
*/
void secStoreRekeyMessage(
      unsigned long   nonce,
      unsigned char   *fqdn,
      unsigned long   time_stamp);



/*
******************************************************************************
** FUNCTION:  secCheckRekeyReplay
**
** PURPOSE:   Check if a rekey message is a replay
**
** PARAMETERS:
**    1. nonce 
**    2. fqdn of call agent
**    3. timestamp form the rekey message
**
**
** RETURNS:
**    FOUND or NOT_FOUND
**
** NOTE:
**
******************************************************************************
*/
int secCheckRekeyReplay(
      unsigned long   nonce,
      unsigned char   *fqdn,
      unsigned long   time_stamp);



#endif
